using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ScreenshotCaptureWithMouse.ScreenCapture;
using System.Runtime.InteropServices;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using System.Threading;
using JumpListHelpers;


namespace ScreenshotCaptureWithMouse
{
	public partial class sswithMouseForm : JumpListMainFormBase
	{
		Thread ta;
		int ScreenNr;
		FormWindowState WindowStateOld;
		BlackScreen BlackForm;
		
		public void tuwas(){
			bool IntersectOld=true;
			while(true){
				EventHandler e = new EventHandler(this.ThreadEvent);

				
				Screen Monitor2=SecondScreen();
				if (Monitor2==null) return;

				Bitmap image=null;
				bool Intersect=CaptureScreen.CaptureDesktopWithCursor(Monitor2.Bounds,ref image,IntersectOld);
				if((Control.MouseButtons & MouseButtons.Left)!=MouseButtons.Left)
					if(Intersect!=IntersectOld){
					IntersectOld=Intersect;
					try{
						this.Invoke(e,new Object[] {Intersect  });
					} catch(Exception){}
				}
				Display(image);
			}
		}

		private void ThreadEvent(object sender, EventArgs e){
			if ((bool)sender){
				{
					this.WindowState=WindowStateOld ;
					this.WindowState = FormWindowState.Maximized;
					this.Visible = true;}
				//Opacity
			}
			else{
				WindowStateOld= this.WindowState;
				this.WindowState = FormWindowState.Minimized;
				this.Visible = true;
			}
		}
		
		public Screen SecondScreen(){
			Screen [] screens = Screen.AllScreens;
			ScreenNr=-1;
			for (int i=0;i<screens.Length;i++){
				if(Screen.PrimaryScreen!=screens[i]) ScreenNr=i;
			}
			if (ScreenNr==-1) {
				return null;
			} else
				return screens[ScreenNr];
		}
		
		public sswithMouseForm(){

			InitializeComponent();

			this.WindowState=FormWindowState.Maximized;

			this.MaximumSize=new Size(this.MaximumSize.Width,Screen.PrimaryScreen.WorkingArea.Height);
			this.Bounds=new Rectangle(0,0,MaximumSize.Width,MaximumSize.Height);
			
			WindowStateOld= this.WindowState;
			
			this.JumpListCommandReceived += new EventHandler<CommandEventArgs>(MainForm_JumpListCommandReceived);
			
			
			Screen sec=SecondScreen();
			
			if (sec==null){
				MessageBox.Show("Program only works with two screens","Only one screen detected");
				return;
			}
			
			InitBlackScreen(false);
		}
		
		public void ThreadStart(){
			ta = new Thread(new ThreadStart(tuwas));
			ta.Priority=ThreadPriority.Highest;
			ta.Start();
		}

		private void Display(Bitmap desktop){
			Graphics g;
			Rectangle r;
			if (desktop != null)
			{
				r = new Rectangle(0,0,ssWithMouseViewer.Width, ssWithMouseViewer.Height);
				g = ssWithMouseViewer.CreateGraphics();
				g.DrawImage(desktop,r);
				g.Flush();
				g.Dispose();
				desktop.Dispose();
			}
		}
		
		void SswithMouseFormFormClosing(object sender, FormClosingEventArgs e){
			try{
				BlackForm.Close();
				ta.Abort();
				ta.Join();
			}
			catch(Exception){}
		}
		
		public void InitBlackScreen(bool visib){
					BlackForm = new BlackScreen();
					BlackForm.Left =Screen.AllScreens[ScreenNr].Bounds.X;
					BlackForm.Top = Screen.AllScreens[ScreenNr].Bounds.Y;
					BlackForm.StartPosition = FormStartPosition.Manual;
					BlackForm.WindowState=FormWindowState.Maximized;
					BlackForm.Show();
					BlackForm.Visible=visib;			
		}
		
		
		private void MainForm_JumpListCommandReceived(object sender, CommandEventArgs e)
		{
			Screen sec=SecondScreen();
			if(sec==null) return;
			Bitmap bit=null;
			if(!CaptureScreen.CaptureDesktopWithCursor(sec.Bounds,ref bit,false)){
				this.WindowState=FormWindowState.Minimized;
			}

			if(e.CommandName=="Black"){
				if(BlackForm.IsDisposed){
					InitBlackScreen(true);
				}
				else if (!BlackForm.Visible){
					BlackForm.Visible=true;
				}
				else{
					BlackForm.Visible=false;
				}
			}
		}
		
		void SswithMouseFormLoad(object sender, EventArgs e){
			JumpListManager.AddCategorySelfLink("Commands", "Second Screen Black", "Black");
			JumpListManager.AddCategorySelfLink("Version","1.0","Version");

			JumpListManager.AddCategoryLink("Links", "Homepage", "http://blog.fakultaet-technik.de/clone-second-screen-into-first-screen/", "shell32.dll", 220);
//			JumpListManager.AddTaskLink("Start Notepad", "notepad.exe", "notepad.exe");

			JumpListManager.Refresh();
			ThreadStart();
		}
	}
}